Merge commit 'dkg/master'
[monkeysphere.git] / src / monkeysphere-server
index 1e05799a00ca9ef64cdabec33ce3a51cc3fa3cdc..4d7acc6cb50276bb7a46ae589d3c6995ed540252 100755 (executable)
@@ -11,7 +11,7 @@
 ########################################################################
 PGRM=$(basename $0)
 
-SHARE=${SHARE:-"/usr/share/monkeysphere"}
+SHARE=${MONKEYSPHERE_SHARE:="/usr/share/monkeysphere"}
 export SHARE
 . "${SHARE}/common" || exit 1
 
@@ -22,10 +22,10 @@ export VARLIB
 DATE=$(date -u '+%FT%T')
 
 # unset some environment variables that could screw things up
-GREP_OPTIONS=
+unset GREP_OPTIONS
 
 # default return code
-ERR=0
+RETURN=0
 
 ########################################################################
 # FUNCTIONS
@@ -33,15 +33,28 @@ ERR=0
 
 usage() {
 cat <<EOF
-usage: $PGRM <subcommand> [args]
+usage: $PGRM <subcommand> [options] [args]
 MonkeySphere server admin tool.
 
 subcommands:
-  update-users (u) [USER]...            update users authorized_keys files
+  update-users (u) [USER]...            update user authorized_keys files
+
   gen-key (g) [HOSTNAME]                generate gpg key for the server
+    -l|--length BITS                      key length in bits (2048)
+    -e|--expire EXPIRE                    date to expire
+    -r|--revoker FINGERPRINT              add a revoker
   show-fingerprint (f)                  show server's host key fingerprint
   publish-key (p)                       publish server's host key to keyserver
-  trust-key (t) KEYID                   import and tsign a certification key
+
+  add-identity-certifier (a) KEYID      import and tsign a certification key
+    -n|--domain DOMAIN                    limit ID certifications to IDs in DOMAIN ()
+    -t|--trust TRUST                      trust level of certifier (full)
+    -d|--depth DEPTH                      trust depth for certifier (1)
+  remove-identity-certifier (r) KEYID   remove a certification key
+  list-identity-certifiers (l)          list certification keys
+
+  gpg-authentication-cmd CMD            gnupg-authentication command
+
   help (h,?)                            this help
 
 EOF
@@ -74,6 +87,9 @@ gpg_host() {
 }
 
 # function to interact with the authentication gnupg keyring
+# FIXME: this function requires basically accepts only a single
+# argument because of problems with quote expansion.  this needs to be
+# fixed/improved.
 gpg_authentication() {
     GNUPGHOME="$GNUPGHOME_AUTHENTICATION"
     export GNUPGHOME
@@ -109,7 +125,7 @@ update_users() {
     for uname in $unames ; do
        # check all specified users exist
        if ! getent passwd "$uname" >/dev/null ; then
-           error "----- unknown user '$uname' -----"
+           log "----- unknown user '$uname' -----"
            continue
        fi
 
@@ -127,6 +143,16 @@ update_users() {
 
        log "----- user: $uname -----"
 
+       if ! check_key_file_permissions "$uname" "$AUTHORIZED_USER_IDS" ; then
+           log "Improper permissions on authorized_user_ids file."
+           continue
+       fi
+
+       if ! check_key_file_permissions "$uname" "$RAW_AUTHORIZED_KEYS" ; then
+           log "Improper permissions on authorized_keys file."
+           continue
+       fi
+
         # make temporary directory
         TMPDIR=$(mktemp -d)
 
@@ -162,7 +188,7 @@ update_users() {
            # user
            su_monkeysphere_user \
                ". ${SHARE}/common; process_authorized_user_ids $TMP_AUTHORIZED_USER_IDS"
-           ERR="$?"
+           RETURN="$?"
        fi
 
        # add user-controlled authorized_keys file path if specified
@@ -184,8 +210,6 @@ update_users() {
        # it into place
        mv -f "$AUTHORIZED_KEYS" "${VARLIB}/authorized_keys/${uname}"
 
-       log "authorized_keys file updated."
-
        # destroy temporary directory
        rm -rf "$TMPDIR"
     done
@@ -193,26 +217,67 @@ update_users() {
 
 # generate server gpg key
 gen_key() {
+    local keyType
+    local keyLength
+    local keyUsage
+    local keyExpire
+    local revoker
     local hostName
     local userID
     local keyParameters
     local fingerprint
 
-    hostName=${1:-$(hostname --fqdn)}
+    # set default key parameter values
+    keyType="RSA"
+    keyLength="2048"
+    keyUsage="auth"
+    keyExpire=
+    revoker=
+
+    # get options
+    TEMP=$(getopt -o l:e:r: -l length:,expire:,revoker: -n "$PGRM" -- "$@")
 
-    SERVICE=${SERVICE:-"ssh"}
-    userID="${SERVICE}://${hostName}"
+    if [ $? != 0 ] ; then
+       exit 1
+    fi
+
+    # Note the quotes around `$TEMP': they are essential!
+    eval set -- "$TEMP"
+
+    while true ; do
+       case "$1" in
+           -l|--length)
+               keyLength="$2"
+               shift 2
+               ;;
+           -e|--expire)
+               keyExpire="$2"
+               shift 2
+               ;;
+           -r|--revoker)
+               revoker="$2"
+               shift 2
+               ;;
+           --)
+               shift
+               ;;
+            *)
+               break
+               ;;
+       esac
+    done
 
+    hostName=${1:-$(hostname --fqdn)}
+    userID="ssh://${hostName}"
+
+    # check for presense of key with user ID
     if gpg_host --list-key ="$userID" > /dev/null 2>&1 ; then
        failure "Key for '$userID' already exists"
     fi
 
-    # set key defaults
-    KEY_TYPE=${KEY_TYPE:-"RSA"}
-    KEY_LENGTH=${KEY_LENGTH:-"2048"}
-    KEY_USAGE=${KEY_USAGE:-"auth"}
-    KEY_EXPIRE=${KEY_EXPIRE:-"0"}
-    cat <<EOF
+    # prompt about key expiration if not specified
+    if [ -z "$keyExpire" ] ; then
+       cat <<EOF
 Please specify how long the key should be valid.
          0 = key does not expire
       <n>  = key expires in n days
@@ -220,26 +285,33 @@ Please specify how long the key should be valid.
       <n>m = key expires in n months
       <n>y = key expires in n years
 EOF
-    read -p "Key is valid for? ($KEY_EXPIRE) " KEY_EXPIRE; KEY_EXPIRE=${KEY_EXPIRE:-"0"}
+       while [ -z "$keyExpire" ] ; do
+           read -p "Key is valid for? (0) " keyExpire
+           if ! test_gpg_expire ${keyExpire:=0} ; then
+               echo "invalid value"
+               unset keyExpire
+           fi
+       done
+    elif ! test_gpg_expire "$keyExpire" ; then
+       failure "invalid key expiration value '$keyExpire'."
+    fi
 
     # set key parameters
     keyParameters=$(cat <<EOF
-Key-Type: $KEY_TYPE
-Key-Length: $KEY_LENGTH
-Key-Usage: $KEY_USAGE
+Key-Type: $keyType
+Key-Length: $keyLength
+Key-Usage: $keyUsage
 Name-Real: $userID
-Expire-Date: $KEY_EXPIRE
+Expire-Date: $keyExpire
 EOF
 )
 
     # add the revoker field if specified
-    # FIXME: the "1:" below assumes that $REVOKER's key is an RSA key.  why?
-    # FIXME: why is this marked "sensitive"?  how will this signature ever
-    # be transmitted to the expected revoker?
-    if [ "$REVOKER" ] ; then
+    # FIXME: the "1:" below assumes that $REVOKER's key is an RSA key.
+    # FIXME: key is marked "sensitive"?  is this appropriate?
+    if [ "$revoker" ] ; then
        keyParameters="${keyParameters}"$(cat <<EOF
-
-Revoker: 1:$REVOKER sensitive
+Revoker: 1:$revoker sensitive
 EOF
 )
     fi
@@ -247,7 +319,7 @@ EOF
     echo "The following key parameters will be used for the host private key:"
     echo "$keyParameters"
 
-    read -p "Generate key? [Y|n]: " OK; OK=${OK:=Y}
+    read -p "Generate key? (Y/n) " OK; OK=${OK:=Y}
     if [ ${OK/y/Y} != 'Y' ] ; then
        failure "aborting."
     fi
@@ -286,7 +358,7 @@ fingerprint_server_key() {
 
 # publish server key to keyserver
 publish_server_key() {
-    read -p "really publish key to $KEYSERVER? [y|N]: " OK; OK=${OK:=N}
+    read -p "Really publish key to $KEYSERVER? (y/N) " OK; OK=${OK:=N}
     if [ ${OK/y/Y} != 'Y' ] ; then
        failure "aborting."
     fi
@@ -295,56 +367,106 @@ publish_server_key() {
     # FIXME: need to figure out better way to identify host key
     # dummy command so as not to publish fakes keys during testing
     # eventually:
-    #gpg_authentication "--keyring $GNUPGHOME_HOST/pubring.gpg --keyserver $KEYSERVER --send-keys $(hostname -f)"
-    failure "NOT PUBLISHED (to avoid permanent publication errors during monkeysphere development)."
+    #gpg_authentication "--keyserver $KEYSERVER --send-keys $(hostname -f)"
+    echo "NOT PUBLISHED (to avoid permanent publication errors during monkeysphere development)."
+    echo "The following command should publish the key:"
+    echo "monkeysphere-server gpg-authentication-cmd '--keyserver $KEYSERVER --send-keys $(hostname -f)'"
+    exit 255
 }
 
-# retrieve key from web of trust, and set owner trust to "full"
-# if key is found.
-trust_key() {
+# retrieve key from web of trust, import it into the host keyring, and
+# ltsign the key in the host keyring so that it may certify other keys
+add_certifier() {
+    local domain
+    local trust
+    local depth
     local keyID
-    local trustLevel
+    local fingerprint
+    local ltsignCommand
+    local trustval
 
-    keyID="$1"
+    # set default values for trust depth and domain
+    domain=
+    trust=full
+    depth=1
 
-    # default values for trust depth and domain
-    DEPTH=${DEPTH:-1}
-    DOMAIN=${DOMAIN:-}
+    # get options
+    TEMP=$(getopt -o n:t:d: -l domain:,trust:,depth: -n "$PGRM" -- "$@")
 
-    if [ -z "$keyID" ] ; then
-       failure "You must specify key to trust."
+    if [ $? != 0 ] ; then
+       exit 1
     fi
 
+    # Note the quotes around `$TEMP': they are essential!
+    eval set -- "$TEMP"
+
+    while true ; do
+       case "$1" in
+           -n|--domain)
+               domain="$2"
+               shift 2
+               ;;
+           -t|--trust)
+               trust="$2"
+               shift 2
+               ;;
+           -d|--depth)
+               depth="$2"
+               shift 2
+               ;;
+           --)
+               shift
+               ;;
+            *)
+               break
+               ;;
+       esac
+    done
+
+    keyID="$1"
+    if [ -z "$keyID" ] ; then
+       failure "You must specify the key ID of a key to add."
+    fi
     export keyID
 
     # export host ownertrust to authentication keyring
     gpg_host --export-ownertrust | gpg_authentication "--import-ownertrust"
 
     # get the key from the key server
-    gpg_authentication "--keyserver $KEYSERVER --recv-key $keyID"
+    gpg_authentication "--keyserver $KEYSERVER --recv-key '$keyID'"
 
     # get the full fingerprint of a key ID
     fingerprint=$(gpg_authentication "--list-key --with-colons --with-fingerprint $keyID" | \
        grep '^fpr:' | grep "$keyID" | cut -d: -f10)
 
-    if [ -z "$fingerprint" ] ; then
-       failure "Could not find key '$keyID'."
-    fi
-
     echo "key found:"
     gpg_authentication "--fingerprint $fingerprint"
 
+    echo "Are you sure you want to add this key as a certifier of"
+    read -p "users on this system? (y/N) " OK; OK=${OK:-N}
+    if [ "${OK/y/Y}" != 'Y' ] ; then
+       failure "aborting."
+    fi
+
     # export the key to the host keyring
     gpg_authentication "--export $keyID" | gpg_host --import
 
+    if [ "$trust" == marginal ]; then
+       trustval=1
+    elif [ "$trust" == full ]; then
+       trustval=2
+    else
+       failure "trust value requested ('$trust') was unclear (only 'marginal' or 'full' are supported)"
+    fi
+
     # ltsign command
     # NOTE: *all* user IDs will be ltsigned
     ltsignCommand=$(cat <<EOF
 ltsign
 y
-2
-$DEPTH
-$DOMAIN
+$trustval
+$depth
+$domain
 y
 save
 EOF
@@ -357,31 +479,60 @@ EOF
     gpg_authentication "--check-trustdb"
 }
 
+# delete a certifiers key from the host keyring
+remove_certifier() {
+    local keyID
+    local fingerprint
+
+    keyID="$1"
+    if [ -z "$keyID" ] ; then
+       failure "You must specify the key ID of a key to remove."
+    fi
+
+    # delete the requested key (with prompting)
+    gpg_host --delete-key "$keyID"
+
+    # update the trustdb for the authentication keyring
+    gpg_authentication "--check-trustdb"
+}
+
+# list the host certifiers
+list_certifiers() {
+    gpg_host --list-keys
+}
+
+# issue command to gpg-authentication keyring
+gpg_authentication_cmd() {
+    gpg_authentication "$@"
+}
+
 ########################################################################
 # MAIN
 ########################################################################
 
-COMMAND="$1"
-[ "$COMMAND" ] || failure "Type '$PGRM help' for usage."
-shift
+# unset variables that should be defined only in config file
+unset KEYSERVER
+unset AUTHORIZED_USER_IDS
+unset RAW_AUTHORIZED_KEYS
+unset MONKEYSPHERE_USER
 
 # load configuration file
-MS_CONF=${MS_CONF:-"${ETC}/monkeysphere-server.conf"}
-[ -e "$MS_CONF" ] && . "$MS_CONF"
+[ -e ${MONKEYSPHERE_SERVER_CONFIG:="${ETC}/monkeysphere-server.conf"} ] && . "$MONKEYSPHERE_SERVER_CONFIG"
 
-# set empty config variable with defaults
-MONKEYSPHERE_USER=${MONKEYSPHERE_USER:-"monkeysphere"}
-KEYSERVER=${KEYSERVER:-"subkeys.pgp.net"}
-CHECK_KEYSERVER=${CHECK_KEYSERVER:="true"}
-AUTHORIZED_USER_IDS=${AUTHORIZED_USER_IDS:-"%h/.config/monkeysphere/authorized_user_ids"}
-RAW_AUTHORIZED_KEYS=${RAW_AUTHORIZED_KEYS:-"%h/.ssh/authorized_keys"}
+# set empty config variable with ones from the environment, or with
+# defaults
+KEYSERVER=${MONKEYSPHERE_KEYSERVER:=${KEYSERVER:="subkeys.pgp.net"}}
+AUTHORIZED_USER_IDS=${MONKEYSPHERE_AUTHORIZED_USER_IDS:=${AUTHORIZED_USER_IDS:="%h/.config/monkeysphere/authorized_user_ids"}}
+RAW_AUTHORIZED_KEYS=${MONKEYSPHERE_RAW_AUTHORIZED_KEYS:=${RAW_AUTHORIZED_KEYS:="%h/.ssh/authorized_keys"}}
+MONKEYSPHERE_USER=${MONKEYSPHERE_MONKEYSPHERE_USER:=${MONKEYSPHERE_USER:="monkeysphere"}}
 
 # other variables
-REQUIRED_USER_KEY_CAPABILITY=${REQUIRED_USER_KEY_CAPABILITY:-"a"}
-GNUPGHOME_HOST=${GNUPGHOME_HOST:-"${VARLIB}/gnupg-host"}
-GNUPGHOME_AUTHENTICATION=${GNUPGHOME_AUTHENTICATION:-"${VARLIB}/gnupg-authentication"}
+CHECK_KEYSERVER=${MONKEYSPHERE_CHECK_KEYSERVER:="true"}
+REQUIRED_USER_KEY_CAPABILITY=${MONKEYSPHERE_REQUIRED_USER_KEY_CAPABILITY:="a"}
+GNUPGHOME_HOST=${MONKEYSPHERE_GNUPGHOME_HOST:="${VARLIB}/gnupg-host"}
+GNUPGHOME_AUTHENTICATION=${MONKEYSPHERE_GNUPGHOME_AUTHENTICATION:="${VARLIB}/gnupg-authentication"}
 
-# export variables
+# export variables needed in su invocation
 export DATE
 export MODE
 export MONKEYSPHERE_USER
@@ -392,6 +543,11 @@ export GNUPGHOME_HOST
 export GNUPGHOME_AUTHENTICATION
 export GNUPGHOME
 
+# get subcommand
+COMMAND="$1"
+[ "$COMMAND" ] || failure "Type '$PGRM help' for usage."
+shift
+
 case $COMMAND in
     'update-users'|'update-user'|'u')
        update_users "$@"
@@ -409,8 +565,20 @@ case $COMMAND in
        publish_server_key
        ;;
 
-    'trust-key'|'t')
-       trust_key "$@"
+    'add-identity-certifier'|'add-certifier'|'a')
+       add_certifier "$1"
+       ;;
+
+    'remove-identity-certifier'|'remove-certifier'|'r')
+       remove_certifier "$1"
+       ;;
+
+    'list-identity-certifiers'|'list-certifiers'|'list-certifier'|'l')
+       list_certifiers "$@"
+       ;;
+
+    'gpg-authentication-cmd')
+       gpg_authentication_cmd "$@"
        ;;
 
     'help'|'h'|'?')
@@ -423,4 +591,4 @@ Type '$PGRM help' for usage."
         ;;
 esac
 
-exit "$ERR"
+exit "$RETURN"